Template Numerical Library: TNL::Matrices::MultidiagonalMatrixElement< Real, Index > Class Template Reference

Template Numerical Library version\ main:be7e16d88

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Protected Attributes | List of all members
TNL::Matrices::MultidiagonalMatrixElement< Real, Index > Class Template Reference

Accessor for multidiagonal matrix elements. More...

`#include <TNL/Matrices/MultidiagonalMatrixElement.h>`

## Public Types
using | IndexType = Index
| Type of matrix elements column indexes.
using | RealType = Real
| Type of matrix elements values.

## Public Member Functions
__cuda_callable__ | MultidiagonalMatrixElement (RealType &value, IndexType rowIdx, IndexType columnIdx, IndexType localIdx)
| Constructor.
__cuda_callable__ const IndexType & | columnIndex () const
| Returns constant reference on matrix element column index.
__cuda_callable__ const IndexType & | localIndex () const
| Returns constant reference on the rank of the non-zero matrix element in the row.
__cuda_callable__ const IndexType & | rowIndex () const
| Returns constant reference on matrix element column index.
__cuda_callable__ RealType & | value ()
| Returns reference on matrix element value.
__cuda_callable__ const RealType & | value () const
| Returns constant reference on matrix element value.

## Protected Attributes
IndexType | columnIdx
IndexType | localIdx
IndexType | rowIdx
RealType & | value_

## Detailed Description

template<typename Real, typename Index>
class TNL::Matrices::MultidiagonalMatrixElement< Real, Index >

Accessor for multidiagonal matrix elements.

Template Parameters

  Real | is a type of matrix elements values.
  Index | is a type of matrix elements column indexes.

## Constructor & Destructor Documentation

## ◆ MultidiagonalMatrixElement()

template<typename Real, typename Index>

__cuda_callable__ TNL::Matrices::MultidiagonalMatrixElement< Real, Index >::MultidiagonalMatrixElement | ( | RealType & | value,
|  | IndexType | rowIdx,
|  | IndexType | columnIdx,
|  | IndexType | localIdx )
| inline

Constructor.

Parameters

  value | is matrix element value.
  rowIdx | is row index of the matrix element.
  columnIdx | is a column index of the matrix element.
  localIdx | is the rank of the non-zero elements in the matrix row.

## Member Function Documentation

## ◆ columnIndex()

template<typename Real, typename Index>

__cuda_callable__ const IndexType & TNL::Matrices::MultidiagonalMatrixElement< Real, Index >::columnIndex | ( |  | ) | const
| inlinenodiscard

Returns constant reference on matrix element column index.

Returns
  constant reference on matrix element column index.

## ◆ localIndex()

template<typename Real, typename Index>

__cuda_callable__ const IndexType & TNL::Matrices::MultidiagonalMatrixElement< Real, Index >::localIndex | ( |  | ) | const
| inlinenodiscard

Returns constant reference on the rank of the non-zero matrix element in the row.

Returns
  constant reference on the rank of the non-zero matrix element in the row.

## ◆ rowIndex()

template<typename Real, typename Index>

__cuda_callable__ const IndexType & TNL::Matrices::MultidiagonalMatrixElement< Real, Index >::rowIndex | ( |  | ) | const
| inlinenodiscard

Returns constant reference on matrix element column index.

Returns
  constant reference on matrix element column index.

## ◆ value() [1/2]

template<typename Real, typename Index>

__cuda_callable__ RealType & TNL::Matrices::MultidiagonalMatrixElement< Real, Index >::value | ( |  | ) |
| inlinenodiscard

Returns reference on matrix element value.

Returns
  reference on matrix element value.

## ◆ value() [2/2]

template<typename Real, typename Index>

__cuda_callable__ const RealType & TNL::Matrices::MultidiagonalMatrixElement< Real, Index >::value | ( |  | ) | const
| inlinenodiscard

Returns constant reference on matrix element value.

Returns
  constant reference on matrix element value.

The documentation for this class was generated from the following file:

- src/TNL/Matrices/MultidiagonalMatrixElement.h